/*
 * Executor
 *
 * Copyright (C) 2009 Christian Franke <nobody@nowhere.ws>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "myapp.h"

#include <QtCore>
#include <QtGui>
#include <unistd.h>
#include <stdlib.h>

#include "lineedit.h"

MyApp::MyApp(int argc, char** argv)
    : QApplication(argc, argv)
    , m_edit(0)
{
    m_edit = new LineEdit();
    connect(m_edit, SIGNAL(returnPressed()), this, SLOT(execute()));
    m_edit->show();
}

void MyApp::execute()
{
    char buffer[100];
    sprintf(buffer,"/tmp/executor-%ld-%d", time(NULL), getpid());
    QFile tFile(buffer);
    if (tFile.open(QIODevice::WriteOnly)) {
        tFile.write("#!/bin/sh\n");
        tFile.write("("+m_edit->text().toAscii()+" &)&");
        tFile.write("\nrm -f ");
        tFile.write(tFile.fileName().toAscii().data());
        tFile.write("\n");
        tFile.setPermissions(QFile::ReadOwner | QFile::WriteOwner | QFile::ExeOwner);
        tFile.close();
        if (fork() == 0) {
            char *args[2];
            args[0] = tFile.fileName().toAscii().data();
            args[1] = NULL;
            execv(tFile.fileName().toAscii().data(), args);
            exit(EXIT_SUCCESS);
        }
        m_edit->hide();
        sleep(2);
        this->quit();
    }
}
